#include <sys/param.h>
#include <sys/ptrace.h>
#include <sys/user.h>
#include <machine/frame.h>
#include <machine/reg.h>

int
md_fetch_eax(int pid)
{
	int val;
	struct reg regs;

	ptrace(PT_GETREGS, pid, (caddr_t)&regs, 0);
	return regs.r_eax;
}

int
md_fetch_esp(int pid)
{
	int val;
	struct reg regs;

	ptrace(PT_GETREGS, pid, (caddr_t)&regs, 0);
	return regs.r_esp;
}

int
md_fetch_eip(int pid)
{
	int val;
	struct reg regs;

	ptrace(PT_GETREGS, pid, (caddr_t)&regs, 0);
	return regs.r_eip;
}

void
md_store_eax(int pid, int val)
{
	struct reg regs;

	ptrace(PT_GETREGS, pid, (caddr_t)&regs, 0);
	regs.r_eax = val;
	ptrace(PT_SETREGS, pid, (caddr_t)&regs, 0);
}

void
md_store_esp(int pid, int val)
{
	struct reg regs;

	ptrace(PT_GETREGS, pid, (caddr_t)&regs, 0);
	regs.r_esp = val;
	ptrace(PT_SETREGS, pid, (caddr_t)&regs, 0);
}

void
md_store_eip(int pid, int val)
{
	struct reg regs;

	ptrace(PT_GETREGS, pid, (caddr_t)&regs, 0);
	regs.r_eip = val;
	ptrace(PT_SETREGS, pid, (caddr_t)&regs, 0);
}
