#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/types.h>
#include <sys/ptrace.h>
#include <sys/param.h>
#include <sys/user.h>
#include <stdio.h>

void * get_instruction_pointer(pid_t pid)
{
	return (void *)md_fetch_eip(pid);
}

void * get_stack_pointer(pid_t pid)
{
	return (void *)md_fetch_esp(pid);
}

void * get_return_addr(pid_t pid, void * stack_pointer)
{
	return (void *)ptrace(PT_READ_I, pid, stack_pointer, 0);
}
